Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp	(revision 1539)
@@ -43,8 +43,7 @@
   {
 
-    if(!comm->is_ep && comm->mpi_comm)
-    {
-      return ::MPI_Allgather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Allgather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Allgather_intercomm(sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, comm);
+
 
     assert(sendcount == recvcount);
@@ -119,7 +118,4 @@
     MPI_Bcast_local(recvbuf, count*ep_size, datatype, 0, comm);
 
-    MPI_Barrier(comm);
-
-
     if(is_master)
     {
@@ -131,4 +127,9 @@
   }
 
+  int MPI_Allgather_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm)
+  {
+    printf("MPI_Allgather_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
 
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1539)
@@ -20,10 +20,6 @@
   {
 
-    if(!comm->is_ep && comm->mpi_comm)
-    {
-      return ::MPI_Allgatherv(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcounts, displs, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
-    }
-
-    if(!comm->mpi_comm) return 0;
+    if(!comm->is_ep) return ::MPI_Allgatherv(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcounts, displs, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Allgatherv_intercomm(sendbuf, sendcount, sendtype, recvbuf, recvcounts, displs, recvtype, comm);
 
 
@@ -114,9 +110,13 @@
       delete[] tmp_recvbuf;
     }
-
-
   }
 
 
+  int MPI_Allgatherv_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, const int recvcounts[], const int displs[], MPI_Datatype recvtype, MPI_Comm comm)
+  {
+    printf("MPI_Allgatherv_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
+
 
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allocate.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allocate.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allocate.cpp	(revision 1539)
@@ -12,5 +12,4 @@
   {
     ::MPI_Alloc_mem(to_mpi_aint(size), to_mpi_info(info), baseptr);
-    //::MPI_Alloc_mem(size.mpi_aint, MPI_INFO_NULL_STD, baseptr);
     return 0;
    }
@@ -19,5 +18,4 @@
   {
     ::MPI_Alloc_mem(size, *(static_cast< ::MPI_Info*>(info->mpi_info)), baseptr);
-    //::MPI_Alloc_mem(size, MPI_INFO_NULL_STD, baseptr);
     return 0;
   }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp	(revision 1539)
@@ -17,13 +17,8 @@
  {
 
-
-
   int MPI_Allreduce(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
   {
-    if(!comm->is_ep && comm->mpi_comm)
-    {
-      return ::MPI_Allreduce(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
-    }
-
+    if(!comm->is_ep) return ::MPI_Allreduce(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Allreduce_intercomm(sendbuf, recvbuf, count, datatype, op, comm);
 
 
@@ -66,8 +61,12 @@
     }
 
-    MPI_Barrier_local(comm);
   }
 
-  
+
+  int MPI_Allreduce_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
+  {
+    printf("MPI_Allreduce_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
 
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1539)
@@ -9,8 +9,6 @@
   int MPI_Alltoall(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm)
   {
-    if(!comm->is_ep)
-    {
-      return ::MPI_Alltoall(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Alltoall(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Alltoall_intercomm(sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, comm);
 
 
@@ -55,10 +53,12 @@
       delete[] tmp_sendbuf;
     }
-    
-    MPI_Barrier(comm);
-
-    return 0;
   }
 
+
+  int MPI_Alltoall_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm)
+  {
+    printf("MPI_Alltoall_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp	(revision 1539)
@@ -9,9 +9,8 @@
   int MPI_Barrier(MPI_Comm comm)
   {
-    if(comm->is_intercomm) return MPI_Barrier_intercomm(comm);
 
     if(comm->is_ep) 
     {
-      return MPI_Barrier_intracomm(comm);
+      return MPI_Barrier_endpoint(comm);
     }
 
@@ -21,5 +20,5 @@
   }
 
-  int MPI_Barrier_intracomm(MPI_Comm comm)
+  int MPI_Barrier_endpoint(MPI_Comm comm)
   {
     int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
@@ -35,17 +34,6 @@
 
     MPI_Barrier_local(comm);
-
-    return 0;
   }
 
-  int MPI_Barrier_intercomm(MPI_Comm comm)
-  {
-    MPI_Barrier_local(comm);
-
-    if(comm->ep_comm_ptr->intercomm->size_rank_info[1].first == 0)
-      ::MPI_Barrier(to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm));
-
-    MPI_Barrier_local(comm);
-  }
 
   int MPI_Barrier_mpi(MPI_Comm comm)
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1539)
@@ -45,10 +45,6 @@
   {
 
-    if(!comm->is_ep)
-    {
-      #pragma omp single nowait
-      ::MPI_Bcast(buffer, count, to_mpi_type(datatype), root, to_mpi_comm(comm->mpi_comm));
-      return 0;
-    }
+    if(!comm->is_ep) return ::MPI_Bcast(buffer, count, to_mpi_type(datatype), root, to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Bcast_intercomm(buffer, count, datatype, root, comm);
 
 
@@ -59,4 +55,6 @@
     int root_mpi_rank = comm->ep_rank_map->at(root).second;
     int root_ep_rank_loc = comm->ep_rank_map->at(root).first;
+
+    //printf("ep_rank = %d, root_mpi_rank = %d, root_ep_rank_loc = %d\n", ep_rank, root_mpi_rank, root_ep_rank_loc);
 
 
@@ -69,9 +67,12 @@
     else                          MPI_Bcast_local(buffer, count, datatype, 0, comm);
 
-    return 0;
   }
 
 
-
+  int MPI_Bcast_intercomm(void *buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm)
+  {
+    printf("MPI_Bcast_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
 
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_comm.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_comm.hpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_comm.hpp	(revision 1539)
@@ -3,5 +3,4 @@
 
 #include "ep_message.hpp"
-#include "ep_intercomm.hpp"
 #include "ep_barrier.hpp"
 #include "ep_buffer.hpp"
@@ -10,6 +9,6 @@
 typedef std::vector< std::pair<int, int> > RANK_MAP;  // at(ep_rank) = <ep_rank_local, mpi_rank>
 typedef std::map<int, std::pair<int, int> > EP_RANK_MAP;  // key(ep_rank) = <ep_rank_local, mpi_rank>
-//typedef std::vector<std::pair< std::pair<int, int>, std::pair<int, int> > > INTERCOMM_RANK_MAP;
 typedef std::list<ep_lib::MPI_Message > Message_list;
+typedef std::map<int, int > INTER_RANK_MAP;
 
 namespace ep_lib
@@ -26,16 +25,8 @@
                                       // 2: mpi_rank,    mpi_size
 
-                                      // for intercomm : = size_rank_info of local_comm
-
-
     ep_comm **comm_list;
 
     Message_list *message_queue;
 
-
-    int comm_label;
-
-    ep_intercomm *intercomm;
-    
   };
   
@@ -52,7 +43,7 @@
     ep_barrier *ep_barrier;
 
-    EP_RANK_MAP   *ep_rank_map;      // for intercomm : = ep_rank_map of newcomm
+    EP_RANK_MAP   *ep_rank_map;
     
-
+    INTER_RANK_MAP *inter_rank_map;
 
     void* mpi_comm;
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1539)
@@ -71,5 +71,4 @@
       out_comm_hdls[idx]->mpi_comm = parent_comm;
       out_comm_hdls[idx]->ep_comm_ptr->comm_list = out_comm_hdls;
-      out_comm_hdls[idx]->ep_comm_ptr->comm_label = 0;
     }
 
@@ -130,6 +129,4 @@
     }
 
-    return 0;
-
   } //MPI_Comm_create_endpoints
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp	(revision 1539)
@@ -7,17 +7,21 @@
 {
 
-  int MPI_Comm_dup_mpi(MPI_Comm comm, MPI_Comm *newcomm)
+  
+  int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm)
   {
-    newcomm = new MPI_Comm;
-    (*newcomm)->is_ep = false;
+    
+    if(!comm->is_ep)
+    {
+      Debug("MPI_Comm_dup with MPI\n");
+      return MPI_Comm_dup_mpi(comm, newcomm); 
+    }
 
-    ::MPI_Comm *output = new ::MPI_Comm;
-      
-    ::MPI_Comm_dup(to_mpi_comm(comm->mpi_comm), output);
-
-    (*newcomm)->mpi_comm = output;
+    return MPI_Comm_dup_endpoint(comm, newcomm); 
+   
   }
 
-  int MPI_Comm_dup_intracomm(MPI_Comm comm, MPI_Comm *newcomm)
+
+  
+  int MPI_Comm_dup_endpoint(MPI_Comm comm, MPI_Comm *newcomm)
   {
     int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
@@ -37,102 +41,30 @@
 
     *newcomm = (comm->ep_comm_ptr->comm_list[0]->mem_bridge[ep_rank_loc]);
+
+    if(comm->is_intercomm)
+    {
+      (*newcomm)->is_intercomm = true;
+      (*newcomm)->ep_comm_ptr->size_rank_info[0] = comm->ep_comm_ptr->size_rank_info[0];
+      (*newcomm)->inter_rank_map = new INTER_RANK_MAP;
+
+      for(INTER_RANK_MAP::iterator it = comm->inter_rank_map->begin(); it !=comm->inter_rank_map->end(); it++)
+      {
+        (*newcomm)->inter_rank_map->insert(std::make_pair(it->first, it->second));
+      }
+
+    }
     
   }
 
-  int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm)
+  int MPI_Comm_dup_mpi(MPI_Comm comm, MPI_Comm *newcomm)
   {
-    
-    if(!comm->is_ep)
-    {
-      Debug("MPI_Comm_dup with MPI\n");
-      return MPI_Comm_dup_mpi(comm, newcomm); 
-    }
+    newcomm = new MPI_Comm;
+    (*newcomm)->is_ep = false;
 
-    if(comm->is_intercomm) return MPI_Comm_dup_intercomm(comm, newcomm);
+    ::MPI_Comm *output = new ::MPI_Comm;
+      
+    ::MPI_Comm_dup(to_mpi_comm(comm->mpi_comm), output);
 
-    
-    return MPI_Comm_dup_intracomm(comm, newcomm); 
-
-   
-  }
-
-  int MPI_Comm_dup_intercomm(MPI_Comm comm, MPI_Comm *newcomm)
-  {
-    
-    int newcomm_ep_rank =comm->ep_comm_ptr->intercomm->size_rank_info[0].first; 
-    int newcomm_ep_rank_loc = comm->ep_comm_ptr->intercomm->size_rank_info[1].first;
-    int newcomm_num_ep = comm->ep_comm_ptr->intercomm->size_rank_info[1].second;
-
-
-    if(0 == newcomm_ep_rank_loc)
-    {
-      //printf("in dup , newcomm_ep_rank_loc = 0 :  ep %d\n", comm->ep_comm_ptr->intercomm->size_rank_info[0].first);
-
-      MPI_Info info;
-      MPI_Comm *out_comm;
-
-      MPI_Comm_create_endpoints(comm->mpi_comm, newcomm_num_ep, info, out_comm);
-
-      ::MPI_Comm *mpi_inter_comm = new ::MPI_Comm;
-      ::MPI_Comm_dup(to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), mpi_inter_comm);
-
-      for(int i=0; i<newcomm_num_ep; i++)
-      {
-        out_comm[i]->is_intercomm = true;
-        out_comm[i]->ep_comm_ptr->comm_label = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->comm_label;
-        out_comm[i]->ep_comm_ptr->intercomm = new ep_lib::ep_intercomm;
-#ifdef _showinfo
-        printf("new out_comm[%d]->ep_comm_ptr->intercomm = %p\n", i, out_comm[i]->ep_comm_ptr->intercomm);
-#endif
-        out_comm[i]->ep_comm_ptr->intercomm->mpi_inter_comm = mpi_inter_comm;
-      }
-
-
-      comm->ep_comm_ptr->comm_list[0]->mem_bridge = out_comm;
-    }
-
-    MPI_Barrier_local(comm);
-
-    *newcomm = (comm->ep_comm_ptr->comm_list[0]->mem_bridge[newcomm_ep_rank_loc]);
-
-    (*newcomm)->ep_comm_ptr->size_rank_info[0] = comm->ep_comm_ptr->size_rank_info[0];
-    (*newcomm)->ep_comm_ptr->size_rank_info[1] = comm->ep_comm_ptr->size_rank_info[1];
-    (*newcomm)->ep_comm_ptr->size_rank_info[2] = comm->ep_comm_ptr->size_rank_info[2];
-
-    (*newcomm)->ep_comm_ptr->intercomm->size_rank_info[0] = comm->ep_comm_ptr->intercomm->size_rank_info[0];
-    (*newcomm)->ep_comm_ptr->intercomm->size_rank_info[1] = comm->ep_comm_ptr->intercomm->size_rank_info[1];
-    (*newcomm)->ep_comm_ptr->intercomm->size_rank_info[2] = comm->ep_comm_ptr->intercomm->size_rank_info[2];
-
-    (*newcomm)->ep_comm_ptr->intercomm->intercomm_tag = comm->ep_comm_ptr->intercomm->intercomm_tag;
-
-
-    int ep_rank_loc = (*newcomm)->ep_comm_ptr->size_rank_info[1].first;
-    
-    if(ep_rank_loc == 0)
-    {
-      int world_rank;
-      MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
-
-      (*newcomm)->ep_comm_ptr->intercomm->intercomm_rank_map = new INTERCOMM_RANK_MAP;
-      (*newcomm)->ep_comm_ptr->intercomm->local_rank_map = new EP_RANK_MAP;
-
-      *(*newcomm)->ep_comm_ptr->intercomm->intercomm_rank_map = *comm->ep_comm_ptr->intercomm->intercomm_rank_map;
-      *(*newcomm)->ep_comm_ptr->intercomm->local_rank_map     = *comm->ep_comm_ptr->intercomm->local_rank_map;
-    }
-
-    MPI_Barrier_local(comm);
-
-    if(ep_rank_loc !=0 )
-    {
-      int target = (*newcomm)->ep_comm_ptr->intercomm->intercomm_tag;
-      (*newcomm)->ep_comm_ptr->intercomm->intercomm_rank_map = (*newcomm)->ep_comm_ptr->comm_list[target]->ep_comm_ptr->intercomm->intercomm_rank_map; 
-      (*newcomm)->ep_comm_ptr->intercomm->local_rank_map     = (*newcomm)->ep_comm_ptr->comm_list[target]->ep_comm_ptr->intercomm->local_rank_map;
-    }
-
-    
-
-
-
-    
+    (*newcomm)->mpi_comm = output;
   }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp	(revision 1539)
@@ -228,8 +228,6 @@
   int MPI_Exscan(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
   {
-    if(!comm->is_ep)
-    {
-      return ::MPI_Scan(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Exscan(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Exscan_intercomm(sendbuf, recvbuf, count, datatype, op, comm);
     
     valid_type(datatype);
@@ -291,12 +289,9 @@
 
     if(ep_rank_loc == 0)
+    {
       ::MPI_Exscan(MPI_IN_PLACE, tmp_recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
-
-    // printf(" ID=%d : %d  %d \n", ep_rank, static_cast<int*>(tmp_recvbuf)[0], static_cast<int*>(tmp_recvbuf)[1]);
+    }
     
     MPI_Exscan_local(tmp_sendbuf, tmp_recvbuf, count, datatype, op, comm);
-
-     // printf(" ID=%d : after local tmp_sendbuf = %d %d ; tmp_recvbuf = %d  %d \n", ep_rank, static_cast<int*>(tmp_sendbuf)[0], static_cast<int*>(tmp_sendbuf)[1], static_cast<int*>(tmp_recvbuf)[0], static_cast<int*>(tmp_recvbuf)[1]);
-
 
 
@@ -314,7 +309,4 @@
 
     else memcpy(recvbuf, tmp_recvbuf, datasize*count);
-    
-
-
 
     delete[] tmp_sendbuf;
@@ -323,3 +315,10 @@
   }
 
+
+  int MPI_Exscan_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
+  {
+    printf("MPI_Exscan_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
+
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp	(revision 1539)
@@ -9,30 +9,12 @@
   int MPI_Finalize()
   {
-    printf("calling EP Finalize\n");
-
-    int id = omp_get_thread_num();
-
-    if(id == 0)
+    #pragma omp master
     {
+      printf("calling EP Finalize\n");
       ::MPI_Finalize();
     }
-    return 0;
   }
 
   int MPI_Abort(MPI_Comm comm, int errorcode)
-  {
-    if(!comm->is_ep)
-      return MPI_Abort_mpi(comm, errorcode);
-
-    else
-    {
-      if(comm->ep_comm_ptr->size_rank_info[1].first == 0)
-      {
-        ::MPI_Abort(to_mpi_comm(comm->mpi_comm), errorcode);
-      }
-    }
-  }
-
-  int MPI_Abort_mpi(MPI_Comm comm, int errorcode)
   {
     return ::MPI_Abort(to_mpi_comm(comm->mpi_comm), errorcode);
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp	(revision 1539)
@@ -9,16 +9,6 @@
   int MPI_Comm_free(MPI_Comm *comm)
   {
-    if(! (*comm)->is_ep)
-    {
-      return MPI_Comm_free_mpi(comm);
-    }
-
-    else 
-    {
-      if((*comm)->is_intercomm)
-        return MPI_Comm_free_intercomm(comm);
-      else
-        return MPI_Comm_free_intracomm(comm);
-    }
+    if(! (*comm)->is_ep) return MPI_Comm_free_mpi(comm);
+    else return MPI_Comm_free_endpoint(comm);
   }
 
@@ -28,10 +18,8 @@
   {
     Debug("MPI_Comm_free with MPI\n");
-
     return ::MPI_Comm_free(to_mpi_comm_ptr((*comm)->mpi_comm));
-    
   }
 
-  int MPI_Comm_free_intracomm(MPI_Comm *comm)
+  int MPI_Comm_free_endpoint(MPI_Comm *comm)
   {
     Debug("MPI_Comm_free with EP_intracomm\n");
@@ -42,8 +30,22 @@
     num_ep = (*comm)->ep_comm_ptr->size_rank_info[1].second;
 
-    MPI_Barrier(*comm);
+    MPI_Barrier_local(*comm);
 
     if(ep_rank_loc == 0)
     {
+
+      if((*comm)->is_intercomm)
+      {
+        for(int i=0; i<num_ep; i++)
+        {
+          (*comm)->ep_comm_ptr->comm_list[i]->inter_rank_map->clear();
+#ifdef _showinfo
+          printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->inter_rank_map = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->inter_rank_map);
+#endif
+          delete (*comm)->ep_comm_ptr->comm_list[i]->inter_rank_map;
+        }
+      }
+
+
 
 #ifdef _showinfo
@@ -103,104 +105,4 @@
 
 
-
-
-
-
-  int MPI_Comm_free_intercomm(MPI_Comm *comm)
-  {
-    int ep_rank;
-    MPI_Comm_rank(*comm, &ep_rank);
-    int ep_rank_loc = (*comm)->ep_comm_ptr->size_rank_info[1].first;
-    int num_ep =      (*comm)->ep_comm_ptr->size_rank_info[1].second;
-    
-    int newcomm_ep_rank =(*comm)->ep_comm_ptr->intercomm->size_rank_info[0].first; 
-    int newcomm_ep_rank_loc = (*comm)->ep_comm_ptr->intercomm->size_rank_info[1].first;
-    int newcomm_num_ep = (*comm)->ep_comm_ptr->intercomm->size_rank_info[1].second;
-
-    return 0;
-    MPI_Barrier(*comm);
-
-    if(ep_rank_loc == 0)
-    {
-      (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map->clear();
-#ifdef _showinfo
-      printf("delete (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map = %p\n", (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map);
-#endif
-      delete (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map;
-
-      (*comm)->ep_comm_ptr->intercomm->local_rank_map->clear();
-#ifdef _showinfo
-      printf("delete (*comm)->ep_comm_ptr->intercomm->local_rank_map = %p\n", (*comm)->ep_comm_ptr->intercomm->local_rank_map);
-#endif
-      delete (*comm)->ep_comm_ptr->intercomm->local_rank_map;
-    }
-
-    if(newcomm_ep_rank_loc == 0)
-    {
-
-#ifdef _showinfo
-      printf("delete (*comm)->my_buffer = %p\n", (*comm)->my_buffer);
-#endif
-      delete (*comm)->my_buffer;
-
-
-      
-#ifdef _showinfo        
-      printf("delete (*comm)->ep_barrier = %p\n", (*comm)->ep_barrier);
-#endif
-      delete (*comm)->ep_barrier;
-      
-
-      (*comm)->ep_rank_map->clear();
-#ifdef _showinfo
-      printf("delete (*comm)->ep_rank_map = %p\n", (*comm)->ep_rank_map);
-#endif
-      delete (*comm)->ep_rank_map;
-      
-#ifdef _showinfo
-      printf("delete (*comm)->ep_comm_ptr->intercomm->mpi_inter_comm = %p\n", (*comm)->ep_comm_ptr->intercomm->mpi_inter_comm);
-#endif
-      ::MPI_Comm_free(to_mpi_comm_ptr((*comm)->ep_comm_ptr->intercomm->mpi_inter_comm));
-
-      for(int i=0; i<newcomm_num_ep; i++)
-      {
-        (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue->clear();
-#ifdef _showinfo
-        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr->message_queue = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue);
-#endif
-        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue;
-
-#ifdef _showinfo
-        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr->intercomm = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm);
-#endif
-        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm;        
-          
-
-#ifdef _showinfo
-        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr);
-#endif
-        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr;
-
-
-#ifdef _showinfo
-        printf("delete (*comm)->ep_comm_ptr->comm_list[%d] = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]);
-#endif
-        delete (*comm)->ep_comm_ptr->comm_list[i];
-
-      }
-
-#ifdef _showinfo
-      printf("delete (*comm)->mpi_comm = %p\n", (*comm)->mpi_comm);
-#endif
-      ::MPI_Comm_free(to_mpi_comm_ptr((*comm)->mpi_comm));
-      
-#ifdef _showinfo
-      printf("delete (*comm)->ep_comm_ptr->comm_list = %p\n", (*comm)->ep_comm_ptr->comm_list);
-#endif
-      delete[] (*comm)->ep_comm_ptr->comm_list;
-    }
-  }
-
-
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gather.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gather.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gather.cpp	(revision 1539)
@@ -35,6 +35,4 @@
       for(int i=0; i<num_ep; i++)
         memcpy(recvbuf + datasize * i * count, comm->my_buffer->void_buffer[i], datasize * count);
-
-      //printf("local_recvbuf = %d %d \n", static_cast<int*>(recvbuf)[0], static_cast<int*>(recvbuf)[1] );
     }
 
@@ -44,9 +42,7 @@
   int MPI_Gather(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm)
   {
-    if(!comm->is_ep)
-    {
-      return ::MPI_Gather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype),
-                   root, to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Gather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype),
+                                         root, to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Gather_intercomm(sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
 
     assert(sendcount == recvcount && sendtype == recvtype);
@@ -103,9 +99,4 @@
     if(is_root)
     {
-      // printf("tmp_recvbuf = %d %d %d %d %d %d %d %d\n", static_cast<int*>(tmp_recvbuf)[0], static_cast<int*>(tmp_recvbuf)[1],
-      //                                                   static_cast<int*>(tmp_recvbuf)[2], static_cast<int*>(tmp_recvbuf)[3],
-      //                                                   static_cast<int*>(tmp_recvbuf)[4], static_cast<int*>(tmp_recvbuf)[5],
-      //                                                   static_cast<int*>(tmp_recvbuf)[6], static_cast<int*>(tmp_recvbuf)[7] );
-
       int offset;
       for(int i=0; i<ep_size; i++)
@@ -128,3 +119,9 @@
   }
 
+
+  int MPI_Gather_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm)
+  {
+    printf("MPI_Gather_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp	(revision 1539)
@@ -46,10 +46,7 @@
   {
   
-    if(!comm->is_ep)
-    {
-      return ::MPI_Gatherv(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, const_cast<int*>(input_recvcounts), const_cast<int*>(input_displs),
-                    to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
-    }
-
+    if(!comm->is_ep) return ::MPI_Gatherv(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, const_cast<int*>(input_recvcounts), const_cast<int*>(input_displs),
+                                          to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Gatherv_intercomm(sendbuf, sendcount, sendtype, recvbuf, input_recvcounts, input_displs, recvtype, root, comm);
 
     assert(sendtype == recvtype);
@@ -169,3 +166,10 @@
   }
 
+  int MPI_Gatherv_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, const int input_recvcounts[], const int input_displs[],
+                            MPI_Datatype recvtype, int root, MPI_Comm comm)
+  {
+    printf("MPI_Gatherv_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
+
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_init.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_init.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_init.cpp	(revision 1539)
@@ -2,5 +2,7 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
+extern MPI_Group MPI_GROUP_WORLD;
 
 namespace ep_lib
@@ -13,7 +15,8 @@
     Debug("MPI_Init_thread with EP/MPI\n");
 
-    if(omp_get_thread_num() == 0)
+    #pragma omp master
     {
       ::MPI_Init_thread(argc, argv, required, provided);
+      ::MPI_Comm_group(to_mpi_comm(MPI_COMM_WORLD->mpi_comm), &MPI_GROUP_WORLD);
     }
   }
@@ -23,13 +26,8 @@
     Debug("MPI_Init with EP/MPI\n");
 
-    if(omp_get_thread_num() == 0)
+    #pragma omp master
     {
       ::MPI_Init(argc, argv);
     }
-  }
-  
-  int EP_group_init()
-  {
-  
   }
 
